Index: uspace/lib/c/generic/bd.c
===================================================================
--- uspace/lib/c/generic/bd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/bd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -32,5 +32,5 @@
 /**
  * @file
- * @brief IP link client stub
+ * @brief Block device client interface
  */
 
Index: uspace/lib/c/generic/clipboard.c
===================================================================
--- uspace/lib/c/generic/clipboard.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/clipboard.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -45,5 +45,5 @@
 #include <ipc/services.h>
 #include <loc.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/c/generic/device/hw_res.c
===================================================================
--- uspace/lib/c/generic/device/hw_res.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/device/hw_res.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <async.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 int hw_res_get_resource_list(async_sess_t *sess,
@@ -140,9 +140,10 @@
  * @param channel DMA channel.
  *
- * @return Number of bytes remaining in the buffer if positive.
- * @return Error code if negative.
+ * @param[out] rem Number of bytes remaining in the buffer if positive.
+ *
+ * @return Error code.
  *
  */
-int hw_res_dma_channel_remain(async_sess_t *sess, unsigned channel)
+int hw_res_dma_channel_remain(async_sess_t *sess, unsigned channel, size_t *rem)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -155,5 +156,5 @@
 	
 	if (ret == EOK)
-		return remain;
+		*rem = remain;
 	
 	return ret;
Index: uspace/lib/c/generic/device/hw_res_parsed.c
===================================================================
--- uspace/lib/c/generic/device/hw_res_parsed.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/device/hw_res_parsed.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,7 +34,7 @@
 
 #include <device/hw_res_parsed.h>
-#include <malloc.h>
 #include <assert.h>
 #include <errno.h>
+#include <stdlib.h>
 
 static void hw_res_parse_add_dma_channel(hw_res_list_parsed_t *out,
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/devman.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,5 +44,5 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 static FIBRIL_MUTEX_INITIALIZE(devman_driver_block_mutex);
Index: uspace/lib/c/generic/dirent.c
===================================================================
--- uspace/lib/c/generic/dirent.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/dirent.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -54,13 +54,14 @@
 	}
 	
-	int fd = vfs_lookup(dirname, WALK_DIRECTORY);
-	if (fd < 0) {
+	int fd;
+	int rc = vfs_lookup(dirname, WALK_DIRECTORY, &fd);
+	if (rc != EOK) {
 		free(dirp);
-		errno = fd;
+		errno = rc;
 		return NULL;
 	}
 	
-	int rc = vfs_open(fd, MODE_READ);
-	if (rc < 0) {
+	rc = vfs_open(fd, MODE_READ);
+	if (rc != EOK) {
 		free(dirp);
 		vfs_put(fd);
Index: uspace/lib/c/generic/elf/elf_load.c
===================================================================
--- uspace/lib/c/generic/elf/elf_load.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/elf/elf_load.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -53,5 +53,5 @@
  * @param file File handle 
  * @param info Place to store ELF program information
- * @return EOK on success or non-zero error code
+ * @return EE_OK on success or an EE_x error code
  */
 int elf_load(int file, elf_info_t *info)
Index: uspace/lib/c/generic/elf/elf_mod.c
===================================================================
--- uspace/lib/c/generic/elf/elf_mod.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/elf/elf_mod.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -69,5 +69,6 @@
 	"incompatible image",
 	"unsupported image type",
-	"irrecoverable error"
+	"irrecoverable error",
+	"file io error"
 };
 
@@ -90,5 +91,5 @@
  *                  extracted from the binary.
  *
- * @return EOK on success or negative error code.
+ * @return EE_OK on success or EE_xx error code.
  *
  */
@@ -97,8 +98,11 @@
 	elf_ld_t elf;
 
-	int ofile = vfs_clone(file, -1, true);
-	int rc = vfs_open(ofile, MODE_READ);
+	int ofile;
+	int rc = vfs_clone(file, -1, true, &ofile);
+	if (rc == EOK) {
+		rc = vfs_open(ofile, MODE_READ);
+	}
 	if (rc != EOK) {
-		return rc;
+		return EE_IO;
 	}
 
@@ -107,8 +111,8 @@
 	elf.flags = flags;
 
-	rc = elf_load_module(&elf, so_bias);
+	int ret = elf_load_module(&elf, so_bias);
 
 	vfs_put(ofile);
-	return rc;
+	return ret;
 }
 
@@ -116,8 +120,13 @@
     elf_finfo_t *info)
 {
-	int file = vfs_lookup(path, 0);
-	int rc = elf_load_file(file, so_bias, flags, info);
-	vfs_put(file);
-	return rc;
+	int file;
+	int rc = vfs_lookup(path, 0, &file);
+	if (rc == EOK) {
+		int ret = elf_load_file(file, so_bias, flags, info);
+		vfs_put(file);
+		return ret;
+	} else {
+		return EE_IO;
+	}
 }
 
@@ -137,10 +146,12 @@
 	elf_header_t *header = &header_buf;
 	aoff64_t pos = 0;
-	int i, rc;
-
-	rc = vfs_read(elf->fd, &pos, header, sizeof(elf_header_t));
-	if (rc != sizeof(elf_header_t)) {
+	size_t nr;
+	int i, ret;
+	int rc;
+
+	rc = vfs_read(elf->fd, &pos, header, sizeof(elf_header_t), &nr);
+	if (rc != EOK || nr != sizeof(elf_header_t)) {
 		DPRINTF("Read error.\n"); 
-		return EE_INVALID;
+		return EE_IO;
 	}
 
@@ -199,13 +210,13 @@
 		pos = header->e_phoff + i * sizeof(elf_segment_header_t);
 		rc = vfs_read(elf->fd, &pos, &segment_hdr,
-		    sizeof(elf_segment_header_t));
-		if (rc != sizeof(elf_segment_header_t)) {
+		    sizeof(elf_segment_header_t), &nr);
+		if (rc != EOK || nr != sizeof(elf_segment_header_t)) {
 			DPRINTF("Read error.\n");
-			return EE_INVALID;
+			return EE_IO;
 		}
 
-		rc = segment_header(elf, &segment_hdr);
-		if (rc != EE_OK)
-			return rc;
+		ret = segment_header(elf, &segment_hdr);
+		if (ret != EE_OK)
+			return ret;
 	}
 
@@ -218,13 +229,13 @@
 		pos = header->e_shoff + i * sizeof(elf_section_header_t);
 		rc = vfs_read(elf->fd, &pos, &section_hdr,
-		    sizeof(elf_section_header_t));
-		if (rc != sizeof(elf_section_header_t)) {
+		    sizeof(elf_section_header_t), &nr);
+		if (rc != EOK || nr != sizeof(elf_section_header_t)) {
 			DPRINTF("Read error.\n");
-			return EE_INVALID;
+			return EE_IO;
 		}
 
-		rc = section_header(elf, &section_hdr);
-		if (rc != EE_OK)
-			return rc;
+		ret = section_header(elf, &section_hdr);
+		if (ret != EE_OK)
+			return ret;
 	}
 
@@ -330,5 +341,6 @@
 	size_t mem_sz;
 	aoff64_t pos;
-	ssize_t rc;
+	int rc;
+	size_t nr;
 
 	bias = elf->bias;
@@ -388,8 +400,8 @@
 	 */
 	pos = entry->p_offset;
-	rc = vfs_read(elf->fd, &pos, seg_ptr, entry->p_filesz);
-	if (rc < 0) {
+	rc = vfs_read(elf->fd, &pos, seg_ptr, entry->p_filesz, &nr);
+	if (rc != EOK || nr != entry->p_filesz) {
 		DPRINTF("read error\n");
-		return EE_INVALID;
+		return EE_IO;
 	}
 
Index: uspace/lib/c/generic/errno.c
===================================================================
--- uspace/lib/c/generic/errno.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/errno.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,7 +36,7 @@
 #include <fibril.h>
 
-static fibril_local int fibril_errno;
+static fibril_local errno_t fibril_errno;
 
-int *__errno(void)
+errno_t *__errno(void)
 {
 	return &fibril_errno;
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/fibril.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,5 +39,5 @@
 #include <stack.h>
 #include <tls.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <abi/mm/as.h>
 #include <as.h>
Index: uspace/lib/c/generic/fibril_synch.c
===================================================================
--- uspace/lib/c/generic/fibril_synch.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/fibril_synch.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -629,40 +629,4 @@
 }
 
-/** Delay fibril execution for the specified number of microseconds
- *
- * @param usec Number of microseconds to sleep
- */
-void fibril_usleep(useconds_t usec)
-{
-	fibril_condvar_t cv;
-	fibril_mutex_t lock;
-
-	fibril_condvar_initialize(&cv);
-	fibril_mutex_initialize(&lock);
-	fibril_mutex_lock(&lock);
-	fibril_condvar_wait_timeout(&cv, &lock, usec);
-	fibril_mutex_unlock(&lock);
-}
-
-/** Delay fibril execution for the specified number of seconds
- *
- * @param sec Number of seconds to sleep
- */
-void fibril_sleep(unsigned int sec)
-{
-	/*
-	 * Sleep in 1000 second steps to support
-	 * full argument range
-	 */
-
-	while (sec > 0) {
-		unsigned int period = (sec > 1000) ? 1000 : sec;
-
-		fibril_usleep(period * 1000000);
-		sec -= period;
-	}
-}
-
-
 /** @}
  */
Index: uspace/lib/c/generic/gsort.c
===================================================================
--- uspace/lib/c/generic/gsort.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/gsort.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,5 +43,5 @@
 #include <inttypes.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 /** Immediate buffer size.
Index: uspace/lib/c/generic/inet/addr.c
===================================================================
--- uspace/lib/c/generic/inet/addr.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/inet/addr.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,5 +39,5 @@
 #include <stdio.h>
 #include <stddef.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <bitops.h>
 #include <inttypes.h>
Index: uspace/lib/c/generic/io/chardev.c
===================================================================
--- uspace/lib/c/generic/io/chardev.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/chardev.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2011 Jan Vesely
+ * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,34 +28,193 @@
  */
 
+/** @addtogroup libc
+ * @{
+ */
+/**
+ * @file
+ * @brief Character device client interface
+ */
+
 #include <errno.h>
 #include <mem.h>
 #include <io/chardev.h>
 #include <ipc/chardev.h>
-
-ssize_t chardev_read(async_exch_t *exch, void *data, size_t size)
-{
-	if (!exch)
-		return EBADMEM;
-	if (size > 4 * sizeof(sysarg_t))
-		return ELIMIT;
-
-	sysarg_t message[4] = { 0 };
-	const ssize_t ret = async_req_1_4(exch, CHARDEV_READ, size,
-	    &message[0], &message[1], &message[2], &message[3]);
-	if (ret > 0 && (size_t)ret <= size)
-		memcpy(data, message, size);
-	return ret;
-}
-
-ssize_t chardev_write(async_exch_t *exch, const void *data, size_t size)
-{
-	if (!exch)
-		return EBADMEM;
-	if (size > 3 * sizeof(sysarg_t))
-		return ELIMIT;
-
-	sysarg_t message[3] = { 0 };
-	memcpy(message, data, size);
-	return async_req_4_0(exch, CHARDEV_WRITE, size,
-	    message[0], message[1], message[2]);
-}
+#include <stddef.h>
+#include <stdlib.h>
+
+/** Open character device.
+ *
+ * @param sess Session with the character device
+ * @param rchardev Place to store pointer to the new character device structure
+ *
+ * @return EOK on success, ENOMEM if out of memory, EIO on I/O error
+ */
+int chardev_open(async_sess_t *sess, chardev_t **rchardev)
+{
+	chardev_t *chardev;
+
+	chardev = calloc(1, sizeof(chardev_t));
+	if (chardev == NULL)
+		return ENOMEM;
+
+	chardev->sess = sess;
+	*rchardev = chardev;
+
+	/* EIO might be used in a future implementation */
+	return EOK;
+}
+
+/** Close character device.
+ *
+ * Frees the character device structure. The underlying session is
+ * not affected.
+ *
+ * @param chardev Character device or @c NULL
+ */
+void chardev_close(chardev_t *chardev)
+{
+	free(chardev);
+}
+
+/** Read from character device.
+ *
+ * Read as much data as is available from character device up to @a size
+ * bytes into @a buf. On success EOK is returned and at least one byte
+ * is read (if no byte is available the function blocks). The number
+ * of bytes read is stored in @a *nread.
+ *
+ * On error a non-zero error code is returned and @a *nread is filled with
+ * the number of bytes that were successfully transferred.
+ *
+ * @param chardev Character device
+ * @param buf Destination buffer
+ * @param size Maximum number of bytes to read
+ * @param nread Place to store actual number of bytes read
+ *
+ * @return EOK on success or non-zero error code
+ */
+int chardev_read(chardev_t *chardev, void *buf, size_t size, size_t *nread)
+{
+	async_exch_t *exch = async_exchange_begin(chardev->sess);
+
+	if (size > DATA_XFER_LIMIT) {
+		/* This should not hurt anything. */
+		size = DATA_XFER_LIMIT;
+	}
+
+	ipc_call_t answer;
+	aid_t req = async_send_0(exch, CHARDEV_READ, &answer);
+	int rc = async_data_read_start(exch, buf, size);
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		*nread = 0;
+		return rc;
+	}
+
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+
+	if (retval != EOK) {
+		*nread = 0;
+		return retval;
+	}
+
+	*nread = IPC_GET_ARG2(answer);
+	/* In case of partial success, ARG1 contains the error code */
+	return IPC_GET_ARG1(answer);
+
+}
+
+/** Write up to DATA_XFER_LIMIT bytes to character device.
+ *
+ * Write up to @a size or DATA_XFER_LIMIT bytes from @a data to character
+ * device. On success EOK is returned, bytes were written and @a *nwritten
+ * is set to min(@a size, DATA_XFER_LIMIT)
+ *
+ * On error a non-zero error code is returned and @a *nwritten is filled with
+ * the number of bytes that were successfully transferred.
+ *
+ * @param chardev Character device
+ * @param buf Destination buffer
+ * @param size Maximum number of bytes to read
+ * @param nwritten Place to store actual number of bytes written
+ *
+ * @return EOK on success or non-zero error code
+ */
+static int chardev_write_once(chardev_t *chardev, const void *data,
+    size_t size, size_t *nwritten)
+{
+	async_exch_t *exch = async_exchange_begin(chardev->sess);
+	ipc_call_t answer;
+	aid_t req;
+	int rc;
+
+	/* Break down large transfers */
+	if (size > DATA_XFER_LIMIT)
+		size = DATA_XFER_LIMIT;
+
+	req = async_send_0(exch, CHARDEV_WRITE, &answer);
+	rc = async_data_write_start(exch, data, size);
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		*nwritten = 0;
+		return rc;
+	}
+
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	if (retval != EOK) {
+		*nwritten = 0;
+		return retval;
+	}
+
+	*nwritten = IPC_GET_ARG2(answer);
+	/* In case of partial success, ARG1 contains the error code */
+	return IPC_GET_ARG1(answer);
+}
+
+/** Write to character device.
+ *
+ * Write @a size bytes from @a data to character device. On success EOK
+ * is returned, all bytes were written and @a *nwritten is set to @a size.
+ *
+ * On error a non-zero error code is returned and @a *nwritten is filled with
+ * the number of bytes that were successfully transferred.
+ *
+ * @param chardev Character device
+ * @param buf Destination buffer
+ * @param size Maximum number of bytes to read
+ * @param nwritten Place to store actual number of bytes written
+ *
+ * @return EOK on success or non-zero error code
+ */
+int chardev_write(chardev_t *chardev, const void *data, size_t size,
+    size_t *nwritten)
+{
+	size_t nw;
+	size_t p;
+	int rc;
+
+	p = 0;
+	while (p < size) {
+		rc = chardev_write_once(chardev, data + p, size - p, &nw);
+		/* nw is always valid, we can have partial success */
+		p += nw;
+
+		if (rc != EOK) {
+			/* We can return partial success */
+			*nwritten = p;
+			return rc;
+		}
+	}
+
+	*nwritten = p;
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/io/chardev_srv.c
===================================================================
--- uspace/lib/c/generic/io/chardev_srv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/chardev_srv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -46,21 +46,41 @@
     ipc_call_t *call)
 {
-	size_t size = IPC_GET_ARG1(*call);
+	void *buf;
+	size_t size;
+	size_t nread;
 	int rc;
+	ipc_callid_t rcallid;
 
-	if (srv->srvs->ops->read == NULL) {
-		async_answer_0(callid, ENOTSUP);
+	if (!async_data_read_receive(&rcallid, &size)) {
+		async_answer_0(callid, EINVAL);
 		return;
 	}
 
-	if (size <= 4 * sizeof(sysarg_t)) {
-		sysarg_t message[4] = {};
+	buf = malloc(size);
+	if (buf == NULL) {
+		async_answer_0(rcallid, ENOMEM);
+		async_answer_0(callid, ENOMEM);
+		return;
+	}
 
-		rc = srv->srvs->ops->read(srv, (char *)message, size);
-		async_answer_4(callid, rc, message[0], message[1],
-		    message[2], message[3]);
-	} else {
-		async_answer_0(callid, ELIMIT);
+	if (srv->srvs->ops->read == NULL) {
+		async_answer_0(rcallid, ENOTSUP);
+		async_answer_0(callid, ENOTSUP);
+		free(buf);
+		return;
 	}
+
+	rc = srv->srvs->ops->read(srv, buf, size, &nread);
+	if (rc != EOK && nread == 0) {
+		async_answer_0(rcallid, rc);
+		async_answer_0(callid, rc);
+		free(buf);
+		return;
+	}
+
+	async_data_read_finalize(rcallid, buf, nread);
+
+	free(buf);
+	async_answer_2(callid, EOK, rc, nread);
 }
 
@@ -68,6 +88,14 @@
     ipc_call_t *call)
 {
-	size_t size = IPC_GET_ARG1(*call);
+	void *data;
+	size_t size;
+	size_t nwr;
 	int rc;
+
+	rc = async_data_write_accept(&data, false, 0, 0, 0, &size);
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		return;
+	}
 
 	if (srv->srvs->ops->write == NULL) {
@@ -76,16 +104,12 @@
 	}
 
-	if (size <= 3 * sizeof(sysarg_t)) {
-		const sysarg_t message[3] = {
-			IPC_GET_ARG2(*call),
-			IPC_GET_ARG3(*call),
-			IPC_GET_ARG4(*call)
-		};
+	rc = srv->srvs->ops->write(srv, data, size, &nwr);
+	free(data);
+	if (rc != EOK && nwr == 0) {
+		async_answer_0(callid, rc);
+		return;
+	}
 
-		rc = srv->srvs->ops->write(srv, (char *)message, size);
-		async_answer_0(callid, rc);
-	} else {
-		async_answer_0(callid, ELIMIT);
-	}
+	async_answer_2(callid, EOK, rc, nwr);
 }
 
@@ -145,5 +169,8 @@
 			break;
 		default:
-			async_answer_0(callid, EINVAL);
+			if (srv->srvs->ops->def_handler != NULL)
+				srv->srvs->ops->def_handler(srv, callid, &call);
+			else
+				async_answer_0(callid, ENOTSUP);
 		}
 	}
Index: uspace/lib/c/generic/io/chargrid.c
===================================================================
--- uspace/lib/c/generic/io/chargrid.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/chargrid.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,5 +34,5 @@
 
 #include <io/style.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <assert.h>
 #include <stdbool.h>
Index: uspace/lib/c/generic/io/con_srv.c
===================================================================
--- uspace/lib/c/generic/io/con_srv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/con_srv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -93,6 +93,7 @@
 	}
 
-	rc = srv->srvs->ops->read(srv, buf, size);
-	if (rc < 0) {
+	size_t nread;
+	rc = srv->srvs->ops->read(srv, buf, size, &nread);
+	if (rc != EOK) {
 		async_answer_0(rcallid, rc);
 		async_answer_0(callid, rc);
@@ -101,11 +102,8 @@
 	}
 
-	async_data_read_finalize(rcallid, buf, size);
+	async_data_read_finalize(rcallid, buf, nread);
 	free(buf);
 
-	if (rc >= 0)
-		async_answer_1(callid, EOK, rc);
-	else
-		async_answer_0(callid, rc);
+	async_answer_1(callid, EOK, nread);
 }
 
@@ -128,11 +126,9 @@
 	}
 
-	rc = srv->srvs->ops->write(srv, data, size);
+	size_t nwritten = 0;
+	rc = srv->srvs->ops->write(srv, data, size, &nwritten);
 	free(data);
 
-	if (rc >= 0)
-		async_answer_1(callid, EOK, rc);
-	else
-		async_answer_0(callid, rc);
+	async_answer_1(callid, rc, nwritten);
 }
 
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/console.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <vfs/vfs_sess.h>
 #include <io/console.h>
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/io.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 #include <errno.h>
 #include <stdbool.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <async.h>
 #include <io/kio.h>
@@ -108,8 +108,8 @@
 	 * This will probably be removed later.
 	 */
-	 
 	int infd = inbox_get("stdin");
 	if (infd >= 0) {
-		int stdinfd = vfs_clone(infd, -1, false);
+		int stdinfd = -1;
+		(void) vfs_clone(infd, -1, false, &stdinfd);
 		assert(stdinfd == 0);
 		vfs_open(stdinfd, MODE_READ);
@@ -122,8 +122,9 @@
 	int outfd = inbox_get("stdout");
 	if (outfd >= 0) {
-		int stdoutfd = vfs_clone(outfd, -1, false);
+		int stdoutfd = -1;
+		(void) vfs_clone(outfd, -1, false, &stdoutfd);
 		assert(stdoutfd <= 1);
 		while (stdoutfd < 1)
-			stdoutfd = vfs_clone(outfd, -1, false);
+			(void) vfs_clone(outfd, -1, false, &stdoutfd);
 		vfs_open(stdoutfd, MODE_APPEND);
 		stdout = fdopen(stdoutfd, "a");
@@ -135,8 +136,9 @@
 	int errfd = inbox_get("stderr");
 	if (errfd >= 0) {
-		int stderrfd = vfs_clone(errfd, -1, false);
+		int stderrfd = -1;
+		(void) vfs_clone(errfd, -1, false, &stderrfd);
 		assert(stderrfd <= 2);
 		while (stderrfd < 2)
-			stderrfd = vfs_clone(errfd, -1, false);
+			(void) vfs_clone(errfd, -1, false, &stderrfd);
 		vfs_open(stderrfd, MODE_APPEND);
 		stderr = fdopen(stderrfd, "a");
@@ -294,12 +296,13 @@
 	if (create)
 		flags |= WALK_MAY_CREATE;
-	int file = vfs_lookup(path, flags);
-	if (file < 0) {
-		errno = file;
+	int file;
+	int rc = vfs_lookup(path, flags, &file);
+	if (rc != EOK) {
+		errno = rc;
 		free(stream);
 		return NULL;
 	}
 
-	int rc = vfs_open(file, mode);
+	rc = vfs_open(file, mode);
 	if (rc != EOK) {
 		errno = rc;
@@ -373,6 +376,6 @@
 	list_remove(&stream->link);
 	
-	if (rc != 0) {
-		/* errno was set by close() */
+	if (rc != EOK) {
+		errno = rc;
 		return EOF;
 	}
@@ -430,17 +433,19 @@
 static size_t _fread(void *buf, size_t size, size_t nmemb, FILE *stream)
 {
+	int rc;
+	size_t nread;
+
 	if (size == 0 || nmemb == 0)
 		return 0;
 
-	ssize_t rd = vfs_read(stream->fd, &stream->pos, buf, size * nmemb);
-	if (rd < 0) {
-		errno = rd;
+	rc = vfs_read(stream->fd, &stream->pos, buf, size * nmemb, &nread);
+	if (rc != EOK) {
+		errno = rc;
 		stream->error = true;
-		rd = 0;
-	} else if (rd == 0) {
+	} else if (nread == 0) {
 		stream->eof = true;
 	}
-	
-	return (rd / size);
+
+	return (nread / size);
 }
 
@@ -457,30 +462,29 @@
 static size_t _fwrite(const void *buf, size_t size, size_t nmemb, FILE *stream)
 {
+	int rc;
+	size_t nwritten;
+
 	if (size == 0 || nmemb == 0)
 		return 0;
 
-	ssize_t wr;
 	if (stream->kio) {
-		size_t nwritten;
-		wr = kio_write(buf, size * nmemb, &nwritten);
-		if (wr != EOK) {
+		rc = kio_write(buf, size * nmemb, &nwritten);
+		if (rc != EOK) {
 			stream->error = true;
-			wr = 0;
-		} else {
-			wr = nwritten;
+			nwritten = 0;
 		}
 	} else {
-		wr = vfs_write(stream->fd, &stream->pos, buf, size * nmemb);
-		if (wr < 0) {
-			errno = wr;
+		rc = vfs_write(stream->fd, &stream->pos, buf, size * nmemb,
+		    &nwritten);
+		if (rc != EOK) {
+			errno = rc;
 			stream->error = true;
-			wr = 0;
 		}
 	}
 
-	if (wr > 0)
+	if (nwritten > 0)
 		stream->need_sync = true;
-	
-	return (wr / size);
+
+	return (nwritten / size);
 }
 
@@ -491,10 +495,12 @@
 static void _ffillbuf(FILE *stream)
 {
-	ssize_t rc;
+	int rc;
+	size_t nread;
 
 	stream->buf_head = stream->buf_tail = stream->buf;
 
-	rc = vfs_read(stream->fd, &stream->pos, stream->buf, stream->buf_size);
-	if (rc < 0) {
+	rc = vfs_read(stream->fd, &stream->pos, stream->buf, stream->buf_size,
+	    &nread);
+	if (rc != EOK) {
 		errno = rc;
 		stream->error = true;
@@ -502,10 +508,10 @@
 	}
 
-	if (rc == 0) {
+	if (nread == 0) {
 		stream->eof = true;
 		return;
 	}
 
-	stream->buf_head += rc;
+	stream->buf_head += nread;
 	stream->buf_state = _bs_read;
 }
Index: uspace/lib/c/generic/io/klog.c
===================================================================
--- uspace/lib/c/generic/io/klog.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/c/generic/io/klog.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,18 +42,14 @@
 #include <abi/log.h>
 
-size_t klog_write(log_level_t lvl, const void *buf, size_t size)
+int klog_write(log_level_t lvl, const void *buf, size_t size)
 {
-	ssize_t ret = (ssize_t) __SYSCALL4(SYS_KLOG, KLOG_WRITE, (sysarg_t) buf,
+	return (int) __SYSCALL4(SYS_KLOG, KLOG_WRITE, (sysarg_t) buf,
 	    size, lvl);
-	
-	if (ret >= 0)
-		return (size_t) ret;
-	
-	return 0;
 }
 
-int klog_read(void *data, size_t size)
+int klog_read(void *data, size_t size, size_t *nread)
 {
-	return (int) __SYSCALL4(SYS_KLOG, KLOG_READ, (uintptr_t) data, size, 0);
+	return (int) __SYSCALL5(SYS_KLOG, KLOG_READ, (uintptr_t) data,
+	    size, 0, (sysarg_t) nread);
 }
 
Index: uspace/lib/c/generic/io/serial.c
===================================================================
--- uspace/lib/c/generic/io/serial.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/lib/c/generic/io/serial.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <async.h>
+#include <errno.h>
+#include <io/serial.h>
+#include <ipc/serial_ctl.h>
+#include <ipc/services.h>
+#include <stdlib.h>
+
+/** Open serial port device.
+ *
+ * @param sess Session with the serial port device
+ * @param rchardev Place to store pointer to the new serial port device structure
+ *
+ * @return EOK on success, ENOMEM if out of memory, EIO on I/O error
+ */
+int serial_open(async_sess_t *sess, serial_t **rserial)
+{
+	serial_t *serial;
+
+	serial = calloc(1, sizeof(serial_t));
+	if (serial == NULL)
+		return ENOMEM;
+
+	serial->sess = sess;
+	*rserial = serial;
+
+	return EOK;
+}
+
+/** Close serial port device.
+ *
+ * Frees the serial port device structure. The underlying session is
+ * not affected.
+ *
+ * @param serial Serial port device or @c NULL
+ */
+void serial_close(serial_t *serial)
+{
+	free(serial);
+}
+
+/** Set serial port communication properties. */
+int serial_set_comm_props(serial_t *serial, unsigned rate,
+    serial_parity_t parity, unsigned datab, unsigned stopb)
+{
+	async_exch_t *exch = async_exchange_begin(serial->sess);
+
+	int rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, rate, parity,
+	    datab, stopb);
+
+	async_exchange_end(exch);
+	return rc;
+}
+
+/** Get serial port communication properties. */
+int serial_get_comm_props(serial_t *serial, unsigned *rrate,
+    serial_parity_t *rparity, unsigned *rdatab, unsigned *rstopb)
+{
+	async_exch_t *exch = async_exchange_begin(serial->sess);
+	sysarg_t rate, parity, datab, stopb;
+
+	int rc = async_req_0_4(exch, SERIAL_GET_COM_PROPS, &rate, &parity,
+	    &datab, &stopb);
+
+	async_exchange_end(exch);
+	if (rc != EOK)
+		return rc;
+
+	*rrate = rate;
+	*rparity = parity;
+	*rdatab = datab;
+	*rstopb = stopb;
+
+	return EOK;
+}
+
+/** @}
+ */
